## Clipboards

Clipboards

## Functions

void | (*GtkClipboardReceivedFunc) ()
void | (*GtkClipboardTextReceivedFunc) ()
void | (*GtkClipboardImageReceivedFunc) ()
void | (*GtkClipboardTargetsReceivedFunc) ()
void | (*GtkClipboardRichTextReceivedFunc) ()
void | (*GtkClipboardURIReceivedFunc) ()
void | (*GtkClipboardGetFunc) ()
void | (*GtkClipboardClearFunc) ()
GtkClipboard * | gtk_clipboard_get ()
GtkClipboard * | gtk_clipboard_get_for_display ()
GdkDisplay * | gtk_clipboard_get_display ()
gboolean | gtk_clipboard_set_with_data ()
gboolean | gtk_clipboard_set_with_owner ()
GObject * | gtk_clipboard_get_owner ()
void | gtk_clipboard_clear ()
void | gtk_clipboard_set_text ()
void | gtk_clipboard_set_image ()
void | gtk_clipboard_request_contents ()
void | gtk_clipboard_request_text ()
void | gtk_clipboard_request_image ()
void | gtk_clipboard_request_targets ()
void | gtk_clipboard_request_rich_text ()
void | gtk_clipboard_request_uris ()
GtkSelectionData * | gtk_clipboard_wait_for_contents ()
gchar * | gtk_clipboard_wait_for_text ()
GdkPixbuf * | gtk_clipboard_wait_for_image ()
guint8 * | gtk_clipboard_wait_for_rich_text ()
gchar ** | gtk_clipboard_wait_for_uris ()
gboolean | gtk_clipboard_wait_is_text_available ()
gboolean | gtk_clipboard_wait_is_image_available ()
gboolean | gtk_clipboard_wait_is_rich_text_available ()
gboolean | gtk_clipboard_wait_is_uris_available ()
gboolean | gtk_clipboard_wait_for_targets ()
gboolean | gtk_clipboard_wait_is_target_available ()
void | gtk_clipboard_set_can_store ()
void | gtk_clipboard_store ()

## Signals

void | owner-change | Run First

## Types and Values

| GtkClipboard

## Object Hierarchy

        GObject
        ╰── GtkClipboard

## Includes

    #include <gtk/gtk.h>

## Description

## Functions

### GtkClipboardReceivedFunc ()

    void
    (*GtkClipboardReceivedFunc) (GtkClipboard *clipboard,
                                 GtkSelectionData *selection_data,
                                 gpointer data);

### GtkClipboardTextReceivedFunc ()

    void
    (*GtkClipboardTextReceivedFunc) (GtkClipboard *clipboard,
                                     const gchar *text,
                                     gpointer data);

### GtkClipboardImageReceivedFunc ()

    void
    (*GtkClipboardImageReceivedFunc) (GtkClipboard *clipboard,
                                      GdkPixbuf *pixbuf,
                                      gpointer data);

### GtkClipboardTargetsReceivedFunc ()

    void
    (*GtkClipboardTargetsReceivedFunc) (GtkClipboard *clipboard,
                                        GdkAtom *atoms,
                                        gint n_atoms,
                                        gpointer data);

### GtkClipboardRichTextReceivedFunc ()

    void
    (*GtkClipboardRichTextReceivedFunc) (GtkClipboard *clipboard,
                                         GdkAtom format,
                                         const guint8 *text,
                                         gsize length,
                                         gpointer data);

### GtkClipboardURIReceivedFunc ()

    void
    (*GtkClipboardURIReceivedFunc) (GtkClipboard *clipboard,
                                    gchar **uris,
                                    gpointer data);

### GtkClipboardGetFunc ()

    void
    (*GtkClipboardGetFunc) (GtkClipboard *clipboard,
                            GtkSelectionData *selection_data,
                            guint info,
                            gpointer user_data_or_owner);

### GtkClipboardClearFunc ()

    void
    (*GtkClipboardClearFunc) (GtkClipboard *clipboard,
                              gpointer user_data_or_owner);

### gtk_clipboard_get ()

    GtkClipboard *
    gtk_clipboard_get (GdkAtom selection);

Returns the clipboard object for the given selection. See `gtk_clipboard_get_for_display()` for complete details.

#### Parameters

selection | a GdkAtom which identifies the clipboard to use |

#### Returns

the appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent and, since it is owned by GTK+, must not be freed or unreffed.

[transfer none]

### gtk_clipboard_get_for_display ()

    GtkClipboard *
    gtk_clipboard_get_for_display (GdkDisplay *display,
                                   GdkAtom selection);

Returns the clipboard object for the given selection. Cut/copy/paste menu items and keyboard shortcuts should use the default clipboard, returned by passing `GDK_SELECTION_CLIPBOARD` for `selection` . (`GDK_NONE` is supported as a synonym for GDK_SELECTION_CLIPBOARD for backwards compatibility reasons.) The currently-selected object or text should be provided on the clipboard identified by GDK_SELECTION_PRIMARY. Cut/copy/paste menu items conceptually copy the contents of the GDK_SELECTION_PRIMARY clipboard to the default clipboard, i.e. they copy the selection to what the user sees as the clipboard.

(Passing GDK_NONE is the same as using `gdk_atom_intern ("CLIPBOARD", FALSE)`. See http://www.freedesktop.org/Standards/clipboards-spec for a detailed discussion of the "CLIPBOARD" vs. "PRIMARY" selections under the X window system. On Win32 the GDK_SELECTION_PRIMARY clipboard is essentially ignored.)

It's possible to have arbitrary named clipboards; if you do invent new clipboards, you should prefix the selection name with an underscore (because the ICCCM requires that nonstandard atoms are underscore-prefixed), and namespace it as well. For example, if your application called "Foo" has a special-purpose clipboard, you might call it "_FOO_SPECIAL_CLIPBOARD".

#### Parameters

display | the display for which the clipboard is to be retrieved or created |
selection | a GdkAtom which identifies the clipboard to use. |

#### Returns

the appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent and, since it is owned by GTK+, must not be freed or unrefd.

[transfer none]

Since: 2.2

### gtk_clipboard_get_display ()

    GdkDisplay *
    gtk_clipboard_get_display (GtkClipboard *clipboard);

Gets the GdkDisplay associated with `clipboard`

#### Parameters

clipboard | a GtkClipboard |

#### Returns

the GdkDisplay associated with `clipboard` .

[transfer none]

Since: 2.2

### gtk_clipboard_set_with_data ()

    gboolean
    gtk_clipboard_set_with_data (GtkClipboard *clipboard,
                                 const GtkTargetEntry *targets,
                                 guint n_targets,
                                 GtkClipboardGetFunc get_func,
                                 GtkClipboardClearFunc clear_func,
                                 gpointer user_data);

Virtually sets the contents of the specified clipboard by providing a list of supported formats for the clipboard data and a function to call to get the actual data when it is requested.

#### Parameters

clipboard | a GtkClipboard |
targets | array containing information about the available forms for the clipboard data |
n_targets | number of elements in `targets` |
get_func | function to call to get the actual clipboard data |
clear_func | when the clipboard contents are set again, this function will be called, and `get_func` will not be subsequently called. |
user_data | user data to pass to `get_func` and `clear_func` . |

#### Returns

`TRUE` if setting the clipboard data succeeded. If setting the clipboard data failed the provided callback functions will be ignored.

### gtk_clipboard_set_with_owner ()

    gboolean
    gtk_clipboard_set_with_owner (GtkClipboard *clipboard,
                                  const GtkTargetEntry *targets,
                                  guint n_targets,
                                  GtkClipboardGetFunc get_func,
                                  GtkClipboardClearFunc clear_func,
                                  GObject *owner);

Virtually sets the contents of the specified clipboard by providing a list of supported formats for the clipboard data and a function to call to get the actual data when it is requested.

The difference between this function and `gtk_clipboard_set_with_data()` is that instead of an generic `user_data` pointer, a GObject is passed in.

#### Parameters

clipboard | a GtkClipboard |
targets | array containing information about the available forms for the clipboard data |
n_targets | number of elements in `targets` |
get_func | function to call to get the actual clipboard data |
clear_func | when the clipboard contents are set again, this function will be called, and `get_func` will not be subsequently called. |
owner | an object that "owns" the data. This object will be passed to the callbacks when called. |

#### Returns

`TRUE` if setting the clipboard data succeeded. If setting the clipboard data failed the provided callback functions will be ignored.

### gtk_clipboard_get_owner ()

    GObject *
    gtk_clipboard_get_owner (GtkClipboard *clipboard);

If the clipboard contents callbacks were set with `gtk_clipboard_set_with_owner()`, and the `gtk_clipboard_set_with_data()` or `gtk_clipboard_clear()` has not subsequently called, returns the owner set by `gtk_clipboard_set_with_owner()`.

#### Parameters

clipboard | a GtkClipboard |

#### Returns

the owner of the clipboard, if any; otherwise `NULL`.

[transfer none]

### gtk_clipboard_clear ()

    void
    gtk_clipboard_clear (GtkClipboard *clipboard);

Clears the contents of the clipboard. Generally this should only be called between the time you call `gtk_clipboard_set_with_owner()` or `gtk_clipboard_set_with_data()`, and when the `clear_func` you supplied is called. Otherwise, the clipboard may be owned by someone else.

#### Parameters

clipboard | a GtkClipboard |

### gtk_clipboard_set_text ()

    void
    gtk_clipboard_set_text (GtkClipboard *clipboard,
                            const gchar *text,
                            gint len);

Sets the contents of the clipboard to the given UTF-8 string. GTK+ will make a copy of the text and take responsibility for responding for requests for the text, and for converting the text into the requested format.

#### Parameters

clipboard | a GtkClipboard object |
text | a UTF-8 string. |
len | length of `text` , in bytes, or -1, in which case the length will be determined with ``strlen()``. |

### gtk_clipboard_set_image ()

    void
    gtk_clipboard_set_image (GtkClipboard *clipboard,
                             GdkPixbuf *pixbuf);

Sets the contents of the clipboard to the given GdkPixbuf. GTK+ will take responsibility for responding for requests for the image, and for converting the image into the requested format.

#### Parameters

clipboard | a GtkClipboard object |
pixbuf | a GdkPixbuf |

Since: 2.6

### gtk_clipboard_request_contents ()

    void
    gtk_clipboard_request_contents (GtkClipboard *clipboard,
                                    GdkAtom target,
                                    GtkClipboardReceivedFunc callback,
                                    gpointer user_data);

Requests the contents of clipboard as the given target. When the results of the result are later received the supplied callback will be called.

#### Parameters

clipboard | a GtkClipboard |
target | an atom representing the form into which the clipboard owner should convert the selection. |
callback | A function to call when the results are received (or the retrieval fails). If the retrieval fails the length field of `selection_data` will be negative. |
user_data | user data to pass to `callback` |

### gtk_clipboard_request_text ()

    void
    gtk_clipboard_request_text (GtkClipboard *clipboard,
                                GtkClipboardTextReceivedFunc callback,
                                gpointer user_data);

Requests the contents of the clipboard as text. When the text is later received, it will be converted to UTF-8 if necessary, and `callback` will be called.

The `text` parameter to `callback` will contain the resulting text if the request succeeded, or `NULL` if it failed. This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into text form.

#### Parameters

clipboard | a GtkClipboard |
callback | a function to call when the text is received, or the retrieval fails. (It will always be called one way or the other.) |
user_data | user data to pass to `callback` . |

### gtk_clipboard_request_image ()

    void
    gtk_clipboard_request_image (GtkClipboard *clipboard,
                                 GtkClipboardImageReceivedFunc callback,
                                 gpointer user_data);

Requests the contents of the clipboard as image. When the image is later received, it will be converted to a GdkPixbuf, and `callback` will be called.

The `pixbuf` parameter to `callback` will contain the resulting GdkPixbuf if the request succeeded, or `NULL` if it failed. This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into an image.

#### Parameters

clipboard | a GtkClipboard |
callback | a function to call when the image is received, or the retrieval fails. (It will always be called one way or the other.) |
user_data | user data to pass to `callback` . |

Since: 2.6

### gtk_clipboard_request_targets ()

    void
    gtk_clipboard_request_targets (GtkClipboard *clipboard,
                                   GtkClipboardTargetsReceivedFunc callback,
                                   gpointer user_data);

Requests the contents of the clipboard as list of supported targets. When the list is later received, `callback` will be called.

The `targets` parameter to `callback` will contain the resulting targets if the request succeeded, or `NULL` if it failed.

#### Parameters

clipboard | a GtkClipboard |
callback | a function to call when the targets are received, or the retrieval fails. (It will always be called one way or the other.) |
user_data | user data to pass to `callback` . |

Since: 2.4

### gtk_clipboard_request_rich_text ()

    void
    gtk_clipboard_request_rich_text (GtkClipboard *clipboard,
                                     GtkTextBuffer *buffer,
                                     GtkClipboardRichTextReceivedFunc callback,
                                     gpointer user_data);

Requests the contents of the clipboard as rich text. When the rich text is later received, `callback` will be called.

The `text` parameter to `callback` will contain the resulting rich text if the request succeeded, or `NULL` if it failed. The `length` parameter will contain `text` 's length. This function can fail for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into rich text form.

#### Parameters

clipboard | a GtkClipboard |
buffer | a GtkTextBuffer |
callback | a function to call when the text is received, or the retrieval fails. (It will always be called one way or the other.) |
user_data | user data to pass to `callback` . |

Since: 2.10

### gtk_clipboard_request_uris ()

    void
    gtk_clipboard_request_uris (GtkClipboard *clipboard,
                                GtkClipboardURIReceivedFunc callback,
                                gpointer user_data);

Requests the contents of the clipboard as URIs. When the URIs are later received `callback` will be called.

The `uris` parameter to `callback` will contain the resulting array of URIs if the request succeeded, or `NULL` if it failed. This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into URI form.

#### Parameters

clipboard | a GtkClipboard |
callback | a function to call when the URIs are received, or the retrieval fails. (It will always be called one way or the other.) |
user_data | user data to pass to `callback` . |

Since: 2.14

### gtk_clipboard_wait_for_contents ()

    GtkSelectionData *
    gtk_clipboard_wait_for_contents (GtkClipboard *clipboard,
                                     GdkAtom target);

Requests the contents of the clipboard using the given target. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

#### Parameters

clipboard | a GtkClipboard |
target | an atom representing the form into which the clipboard owner should convert the selection. |

#### Returns

a newly-allocated GtkSelectionData object or `NULL` if retrieving the given target failed. If non-`NULL`, this value must be freed with `gtk_selection_data_free()` when you are finished with it.

### gtk_clipboard_wait_for_text ()

    gchar *
    gtk_clipboard_wait_for_text (GtkClipboard *clipboard);

Requests the contents of the clipboard as text and converts the result to UTF-8 if necessary. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

#### Parameters

clipboard | a GtkClipboard |

#### Returns

a newly-allocated UTF-8 string which must be freed with `g_free()`, or `NULL` if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into text form.)

### gtk_clipboard_wait_for_image ()

    GdkPixbuf *
    gtk_clipboard_wait_for_image (GtkClipboard *clipboard);

Requests the contents of the clipboard as image and converts the result to a GdkPixbuf. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

#### Parameters

clipboard | a GtkClipboard |

#### Returns

a newly-allocated GdkPixbuf object which must be disposed with `g_object_unref()`, or `NULL` if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into an image.).

[transfer full]

Since: 2.6

### gtk_clipboard_wait_for_rich_text ()

    guint8 *
    gtk_clipboard_wait_for_rich_text (GtkClipboard *clipboard,
                                      GtkTextBuffer *buffer,
                                      GdkAtom *format,
                                      gsize *length);

Requests the contents of the clipboard as rich text. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

#### Parameters

clipboard | a GtkClipboard |
buffer | a GtkTextBuffer |
format | return location for the format of the returned data |
length | return location for the length of the returned data |

#### Returns

a newly-allocated binary block of data which must be freed with `g_free()`, or `NULL` if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into text form.).

[array length=length][transfer full]

Since: 2.10

### gtk_clipboard_wait_for_uris ()

    gchar **
    gtk_clipboard_wait_for_uris (GtkClipboard *clipboard);

Requests the contents of the clipboard as URIs. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

#### Parameters

clipboard | a GtkClipboard |

#### Returns

a newly-allocated `NULL`-terminated array of strings which must be freed with `g_strfreev()`, or `NULL` if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into URI form.).

[array zero-terminated=1][element-type utf8][transfer full]

Since: 2.14

### gtk_clipboard_wait_is_text_available ()

    gboolean
    gtk_clipboard_wait_is_text_available (GtkClipboard *clipboard);

Test to see if there is text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported text targets. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling `gtk_clipboard_wait_for_text()` since it doesn't need to retrieve the actual text.

#### Parameters

clipboard | a GtkClipboard |

#### Returns

`TRUE` is there is text available, `FALSE` otherwise.

### gtk_clipboard_wait_is_image_available ()

    gboolean
    gtk_clipboard_wait_is_image_available (GtkClipboard *clipboard);

Test to see if there is an image available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported image targets. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling `gtk_clipboard_wait_for_image()` since it doesn't need to retrieve the actual image data.

#### Parameters

clipboard | a GtkClipboard |

#### Returns

`TRUE` is there is an image available, `FALSE` otherwise.

Since: 2.6

### gtk_clipboard_wait_is_rich_text_available ()

    gboolean
    gtk_clipboard_wait_is_rich_text_available
                                   (GtkClipboard *clipboard,
                                    GtkTextBuffer *buffer);

Test to see if there is rich text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the supported rich text targets. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling `gtk_clipboard_wait_for_rich_text()` since it doesn't need to retrieve the actual text.

#### Parameters

clipboard | a GtkClipboard |
buffer | a GtkTextBuffer |

#### Returns

`TRUE` is there is rich text available, `FALSE` otherwise.

Since: 2.10

### gtk_clipboard_wait_is_uris_available ()

    gboolean
    gtk_clipboard_wait_is_uris_available (GtkClipboard *clipboard);

Test to see if there is a list of URIs available to be pasted This is done by requesting the TARGETS atom and checking if it contains the URI targets. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling `gtk_clipboard_wait_for_uris()` since it doesn't need to retrieve the actual URI data.

#### Parameters

clipboard | a GtkClipboard |

#### Returns

`TRUE` is there is an URI list available, `FALSE` otherwise.

Since: 2.14

### gtk_clipboard_wait_for_targets ()

    gboolean
    gtk_clipboard_wait_for_targets (GtkClipboard *clipboard,
                                    GdkAtom **targets,
                                    gint *n_targets);

Returns a list of targets that are present on the clipboard, or `NULL` if there aren't any targets available. The returned list must be freed with `g_free()`. This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

#### Parameters

clipboard | a GtkClipboard |
targets | location to store an array of targets. The result stored here must be freed with `g_free()`. | [out][array length=n_targets][transfer container]
n_targets | location to store number of items in `targets` . |

#### Returns

`TRUE` if any targets are present on the clipboard, otherwise `FALSE`.

Since: 2.4

### gtk_clipboard_wait_is_target_available ()

    gboolean
    gtk_clipboard_wait_is_target_available
                                   (GtkClipboard *clipboard,
                                    GdkAtom target);

Checks if a clipboard supports pasting data of a given type. This function can be used to determine if a "Paste" menu item should be insensitive or not.

If you want to see if there's text available on the clipboard, use `gtk_clipboard_wait_is_text_available()` instead.

#### Parameters

clipboard | a GtkClipboard |
target | A GdkAtom indicating which target to look for. |

#### Returns

`TRUE` if the target is available, `FALSE` otherwise.

Since: 2.6

### gtk_clipboard_set_can_store ()

    void
    gtk_clipboard_set_can_store (GtkClipboard *clipboard,
                                 const GtkTargetEntry *targets,
                                 gint n_targets);

Hints that the clipboard data should be stored somewhere when the application exits or when `gtk_clipboard_store()` is called.

This value is reset when the clipboard owner changes. Where the clipboard data is stored is platform dependent, see `gdk_display_store_clipboard()` for more information.

#### Parameters

clipboard | a GtkClipboard |
targets | array containing information about which forms should be stored or `NULL` to indicate that all forms should be stored. | [allow-none][array length=n_targets]
n_targets | number of elements in `targets` |

Since: 2.6

### gtk_clipboard_store ()

    void
    gtk_clipboard_store (GtkClipboard *clipboard);

Stores the current clipboard data somewhere so that it will stay around after the application has quit.

#### Parameters

clipboard | a GtkClipboard |

Since: 2.6

## Types and Values

### GtkClipboard

    typedef struct _GtkClipboard GtkClipboard;

## Signal Details

### The `“owner-change”` signal

    void
    user_function (GtkClipboard *clipboard,
                   GdkEvent     *event,
                   gpointer      user_data)

The ::owner-change signal is emitted when GTK+ receives an event that indicates that the ownership of the selection associated with `clipboard` has changed.

#### Parameters

clipboard | the GtkClipboard on which the signal is emitted |
event | the `GdkEventOwnerChange` event |
user_data | user data set when the signal handler was connected. |

Flags: Run First

Since: 2.6